package com.laihua.projecthelper.unuse

import java.io.File

/**
 * Author: pengjunjing
 * Date: 2022/3/4
 * Description:
 */
class ReadUtil {

    //读取图片资源
    fun readImageRes(file: File): MutableList<File> {
        val resResult = mutableListOf<File>()
        resResult.clear()
        if (file.exists() && file.isDirectory) {
            readChildFile(file, ".gif", ".png", ".jpg", ".webp", ".9", resultList = resResult)
        } else {
            println("资源目录不存在或者传入的不是目录:${file.absolutePath}")
        }
        return resResult
    }


    /**
     * 读取代码文件
     */
    fun readCodeFile(file: File): MutableList<File> {
        val codeResult = mutableListOf<File>()
        codeResult.clear()
        if (file.exists() && file.isDirectory) {
            readChildFile(file, ".java", ".kt", ".xml", resultList = codeResult)
        } else {
            println("资源目录不存在或者传入的不是目录:${file.absolutePath}")
        }
        return codeResult
    }

    private val excludeXml = arrayOf("values", "AndroidManifest","res/xml","res\\xml")

    /**
     * 读取xml图片文件
     */
    fun readXmlFile(file: File): List<File> {
        val result = mutableListOf<File>()
        if (file.exists() && file.isDirectory) {
            readChildFile(file, ".xml", resultList = result)
        } else {
            println("资源目录不存在或者传入的不是目录:${file.absolutePath}")
        }

        return result.filter {
            var filterResult = true
            for (exclude in excludeXml) {
                //排除掉部分xml文件
                if (it.absolutePath.contains(exclude,ignoreCase = true)) {
                    filterResult = false
                    break
                }
            }
            filterResult
        }
    }


    companion object {
        //排除目录
        private val excludeDir = arrayOf("build", ".git", ".gradle", ".idea")

        /**
         * @param fileType 文件后缀名
         */
        private fun readChildFile(file: File, vararg fileType: String, resultList: MutableList<File>) {
            val listFiles = file.listFiles()
            if (listFiles != null && listFiles.isNotEmpty()) {
                //该目录下存在文件or文件夹
                out@ for (it in listFiles) {
                    if (it.isDirectory) {
                        for (s in excludeDir) {
                            if (it.name.equals(s)) {
                                //排除指定目录
                                continue@out
                            }
                        }
                        //目录递归遍历
                        readChildFile(it, *fileType, resultList = resultList)
                    } else if (it.isFile) {
                        for (s in fileType) {
                            if (it.name.lowercase().endsWith(s.lowercase())) {
                                //文件后缀名匹配
                                resultList.add(it)
                            }
                        }
                    }
                }
            }
        }
    }


}